# class connectionImpl | This class is an abstract baseclass to actually implement the comunication with the database. More...
Contains pure virtuals
Full name | `toConnection::connectionImpl`
Definition | `#include <toconnection.h>`
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- toConnection & connection (void)
- connectionImpl (toConnection *conn)
- virtual ~connectionImpl ()
- virtual void commit (toConnectionSub *)
- virtual void rollback (toConnectionSub *)
- virtual toConnectionSub * createConnection (void)
- virtual void closeConnection (toConnectionSub *)
- virtual QString version (toConnectionSub *)
- virtual connectionImpl * clone (toConnection *newConn) const
- virtual QString quote (const QString &name)
- virtual QString unQuote (const QString &name)
- virtual std::list objectNames (void)
- virtual std::map<QString,objectName> synonymMap (std::list &objects)
- virtual toQDescList columnDesc (const objectName &table)
- virtual toQuery::queryImpl * createQuery (toQuery *query,toConnectionSub *conn)
- virtual void execute (toConnectionSub *conn,const QCString &sql,toQList ¶ms)

## Detailed Description

This class is an abstract baseclass to actually implement the comunication with the database. (See also toQuery::queryImpl and toConnectionProvider)

toConnection & connection (void) | ### connection

Get the parent connection object of this connection.

connectionImpl (toConnection *conn) | ### connectionImpl

Create a new connection implementation for a connection.

Parameters:

conn | Connection to implement.

~connectionImpl () | ### ~connectionImpl

[virtual]

Destructor.

void commit (toConnectionSub *) | ### commit

[pure virtual]

Commit the supplied actual database connection.

void rollback (toConnectionSub *) | ### rollback

[pure virtual]

Rollback the supplied actual database connection.

toConnectionSub * createConnection (void) | ### createConnection

[pure virtual]

Create a new connection to the database.

void closeConnection (toConnectionSub *) | ### closeConnection

[pure virtual]

Close a connection to the database.

QString version (toConnectionSub *) | ### version

[pure virtual]

Get the version of the database connected to.

connectionImpl * clone (toConnection *newConn) | ### clone

[const pure virtual]

Create a copy of this implementation.

QString quote (const QString &name) | ### quote

[virtual]

Return a string representation to address an object.

Parameters:

name | The name to be quoted.

Returns: String addressing table.

QString unQuote (const QString &name) | ### unQuote

[virtual]

Perform the opposite of quote.

Parameters:

name | The name to be un-quoted.

Returns: String addressing table.

std::list objectNames (void) | ### objectNames

[virtual]

Extract available objects to query for connection. Any access to the database should always be run using a long running query. If something goes wrong should throw exception.

Returns: List of available objects.

std::map<QString,objectName> synonymMap (std::list &objects) | ### synonymMap

[virtual]

Get synonyms available for connection. Any access to the database should always be run using a long running query. If something goes wrong should throw exception.

Parameters:

objects | Available objects for the connection. Objects are sorted in owner and name order. Don't modify this list.

Returns: Map of synonyms to objectnames.

toQDescList columnDesc (const objectName &table) | ### columnDesc

[virtual]

toQuery::queryImpl * createQuery (toQuery *query,toConnectionSub *conn) | ### createQuery

[pure virtual]

Create a new query implementation for this connection.

Returns: A query implementation, allocated with new.

void execute (toConnectionSub *conn,const QCString &sql,toQList ¶ms) | ### execute

[pure virtual]

Execute a query on an actual connection without caring about the result.

Parameters:

conn | Connection to execute on.
sql | SQL to execute.
params | Parameters to pass to query.